# coding: utf-8

"""
    VRt.Studio [ST]

    The version of the OpenAPI document: 6.10.2076

    Generated by OpenAPI Generator: 6.6.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, confloat, conint
from vrt_lss_studio.models.capacity import Capacity
from vrt_lss_studio.models.measurements import Measurements
from vrt_lss_studio.models.quality_statistics import QualityStatistics

class Statistics(BaseModel):
    """
    General statistics for one or more trips. 
    """
    cost: Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)] = Field(..., description="Total costs calculated based on the performer's and transport tariffs. The total cost is equal to the difference between the total reward (`reward`) and expenses (`cost`). ")
    reward: Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)] = Field(..., description="The total reward for orders fulfillment.")
    measurements: Measurements = Field(...)
    trips_count: conint(strict=True, le=15001, ge=0) = Field(..., description="The total number of planned trips.")
    performers_count: conint(strict=True, le=15001, ge=0) = Field(..., description="The total number of performers involved in orders fulfillment.")
    orders_count: conint(strict=True, le=15001, ge=0) = Field(..., description="The total number of planned and assigned orders.")
    plan_orders_count: conint(strict=True, le=15001, ge=0) = Field(..., description="The total number of planned orders.")
    waitlist_orders_count: conint(strict=True, le=15001, ge=0) = Field(..., description="The total number of assigned orders.")
    cargo_capacity_ratio: Optional[Capacity] = Field(...)
    max_transport_load: Optional[Capacity] = Field(...)
    quality: Optional[QualityStatistics] = None
    __properties = ["cost", "reward", "measurements", "trips_count", "performers_count", "orders_count", "plan_orders_count", "waitlist_orders_count", "cargo_capacity_ratio", "max_transport_load", "quality"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Statistics:
        """Create an instance of Statistics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of measurements
        if self.measurements:
            _dict['measurements'] = self.measurements.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cargo_capacity_ratio
        if self.cargo_capacity_ratio:
            _dict['cargo_capacity_ratio'] = self.cargo_capacity_ratio.to_dict()
        # override the default output from pydantic by calling `to_dict()` of max_transport_load
        if self.max_transport_load:
            _dict['max_transport_load'] = self.max_transport_load.to_dict()
        # override the default output from pydantic by calling `to_dict()` of quality
        if self.quality:
            _dict['quality'] = self.quality.to_dict()
        # set to None if cargo_capacity_ratio (nullable) is None
        # and __fields_set__ contains the field
        if self.cargo_capacity_ratio is None and "cargo_capacity_ratio" in self.__fields_set__:
            _dict['cargo_capacity_ratio'] = None

        # set to None if max_transport_load (nullable) is None
        # and __fields_set__ contains the field
        if self.max_transport_load is None and "max_transport_load" in self.__fields_set__:
            _dict['max_transport_load'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Statistics:
        """Create an instance of Statistics from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Statistics.parse_obj(obj)

        _obj = Statistics.parse_obj({
            "cost": obj.get("cost"),
            "reward": obj.get("reward"),
            "measurements": Measurements.from_dict(obj.get("measurements")) if obj.get("measurements") is not None else None,
            "trips_count": obj.get("trips_count"),
            "performers_count": obj.get("performers_count"),
            "orders_count": obj.get("orders_count"),
            "plan_orders_count": obj.get("plan_orders_count"),
            "waitlist_orders_count": obj.get("waitlist_orders_count"),
            "cargo_capacity_ratio": Capacity.from_dict(obj.get("cargo_capacity_ratio")) if obj.get("cargo_capacity_ratio") is not None else None,
            "max_transport_load": Capacity.from_dict(obj.get("max_transport_load")) if obj.get("max_transport_load") is not None else None,
            "quality": QualityStatistics.from_dict(obj.get("quality")) if obj.get("quality") is not None else None
        })
        return _obj

