# coding: utf-8

"""
    VRt.Studio [ST]

    The version of the OpenAPI document: 6.10.2076

    Generated by OpenAPI Generator: 6.6.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conint, conlist, constr, validator
from vrt_lss_studio.models.basic_time_window import BasicTimeWindow

class TablePerformerFields(BaseModel):
    """
    Performer and shift fields for table.
    """
    essence_key: Optional[constr(strict=True, max_length=1024, min_length=1)] = Field(None, description="Key, unique identifier.")
    essence_type: Optional[StrictStr] = Field('PERFORMER', description="Essence type.")
    enabled: Optional[StrictBool] = Field(True, description="Using essence for calculations.")
    pristine: Optional[StrictBool] = Field(True, description="A flag indicating whether changes to the entity have been made relative to the original data. `true` - means that the data is original and has not been changed. ")
    working_time: Optional[BasicTimeWindow] = None
    availability_time: Optional[BasicTimeWindow] = None
    trip_key: Optional[constr(strict=True, max_length=1024, min_length=1)] = Field(None, description="Key, unique identifier.")
    trip_name: Optional[constr(strict=True, max_length=64, min_length=0)] = Field('', description="Trip name.")
    location_keys: Optional[conlist(constr(strict=True, max_length=1024, min_length=1), max_items=15001, min_items=0)] = Field(None, description="A list of keys.")
    trips_count: Optional[conint(strict=True, le=15001, ge=0)] = Field(0, description="The number of trips in which the performer participates (for a shift - 0 or 1).")
    attributes: Optional[constr(strict=True, max_length=1000000, min_length=0)] = Field('', description="Attributes.")
    __properties = ["essence_key", "essence_type", "enabled", "pristine", "working_time", "availability_time", "trip_key", "trip_name", "location_keys", "trips_count", "attributes"]

    @validator('essence_type')
    def essence_type_validate_enum(cls, v):
        if v is None:
            return v
        if v not in ('PERFORMER', 'SHIFT'):
            raise ValueError("must be one of enum values ('PERFORMER', 'SHIFT')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TablePerformerFields:
        """Create an instance of TablePerformerFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "pristine",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of working_time
        if self.working_time:
            _dict['working_time'] = self.working_time.to_dict()
        # override the default output from pydantic by calling `to_dict()` of availability_time
        if self.availability_time:
            _dict['availability_time'] = self.availability_time.to_dict()
        # set to None if essence_key (nullable) is None
        # and __fields_set__ contains the field
        if self.essence_key is None and "essence_key" in self.__fields_set__:
            _dict['essence_key'] = None

        # set to None if working_time (nullable) is None
        # and __fields_set__ contains the field
        if self.working_time is None and "working_time" in self.__fields_set__:
            _dict['working_time'] = None

        # set to None if availability_time (nullable) is None
        # and __fields_set__ contains the field
        if self.availability_time is None and "availability_time" in self.__fields_set__:
            _dict['availability_time'] = None

        # set to None if trip_key (nullable) is None
        # and __fields_set__ contains the field
        if self.trip_key is None and "trip_key" in self.__fields_set__:
            _dict['trip_key'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TablePerformerFields:
        """Create an instance of TablePerformerFields from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TablePerformerFields.parse_obj(obj)

        _obj = TablePerformerFields.parse_obj({
            "essence_key": obj.get("essence_key"),
            "essence_type": obj.get("essence_type") if obj.get("essence_type") is not None else 'PERFORMER',
            "enabled": obj.get("enabled") if obj.get("enabled") is not None else True,
            "pristine": obj.get("pristine") if obj.get("pristine") is not None else True,
            "working_time": BasicTimeWindow.from_dict(obj.get("working_time")) if obj.get("working_time") is not None else None,
            "availability_time": BasicTimeWindow.from_dict(obj.get("availability_time")) if obj.get("availability_time") is not None else None,
            "trip_key": obj.get("trip_key"),
            "trip_name": obj.get("trip_name") if obj.get("trip_name") is not None else '',
            "location_keys": obj.get("location_keys"),
            "trips_count": obj.get("trips_count") if obj.get("trips_count") is not None else 0,
            "attributes": obj.get("attributes") if obj.get("attributes") is not None else ''
        })
        return _obj

